#include <Wire.h>
#include <SPI.h>
//#include <KX022.h>
#include <SFE_MicroOLED.h>  // Include the SFE_MicroOLED library
#include  <avr/dtostrf.h>
#include "SI114.h"
#include <BLEPeripheral.h>
#include "BLESerial.h"
BLESerial bleSerial(10, 2, 9);
unsigned long long lastSent = 0;
#define AMBIENT_LIGHT_SAMPLING
#define OLED_WIDTH 64
#define OLED_HEIGHT 32
MicroOLED oled(OLED_RST, OLED_DC, OLED_CS); // (pin_rst, pin_dc, pin_cs)
float xyz[3];
uint32_t tPage;
bool B1_isPressed = false;
uint8_t page_num = 0;
const uint8_t page_count = 2;
void draw_page(uint8_t idx = 0);
//heartrate sensor si114
const int SAMPLES_TO_AVERAGE = 2;
int binOut;     // 1 or 0 depending on state of heartbeat
int BPM;
unsigned long red;        // read value from visible red LED  ------ only one that gives result
unsigned long IR1;        // read value from infrared LED1
unsigned long IR2J;       // read value from infrared LED2
unsigned long total;     // all three LED reads added together
int signalSize;          // the heartbeat signal minus the offset
const int portForSI114 = 0; //for SI114 JJ
PortI2C myBus (portForSI114);
PulsePlug pulse (myBus);
unsigned long CurrentMillis;
unsigned long PreviousMillis = 1;
unsigned long IntervalMillis = 2000;
void setup()
{
  Wire.begin();
  bleSerial.setLocalName("UART4");
  bleSerial.begin();
  delay(3000); // show splash for 3s
  initPulseSensor();
}

void loop()
{

CurrentMillis = millis();
         if((CurrentMillis - PreviousMillis) >= IntervalMillis) 
         {
 PreviousMillis = CurrentMillis;
 int test_vis =pulse.getReg(PulsePlug::ALS_VIS_DATA0)+256*pulse.getReg(PulsePlug::ALS_VIS_DATA1);
 int test_ir =pulse.getReg(PulsePlug::ALS_IR_DATA0)+256*pulse.getReg(PulsePlug::ALS_IR_DATA1);
 bleSerial.print("V");
 bleSerial.print(test_vis);
 bleSerial.print(",");
 bleSerial.print("R");
 bleSerial.print(test_ir);
 bleSerial.println();

         }
}


void initPulseSensor() {
  pulse.setReg(PulsePlug::HW_KEY, 0x17);
  pulse.setReg(PulsePlug::INT_CFG, 0x03);       // turn on interrupts
  // pulse.setReg(PulsePlug::IRQ_ENABLE, 0x10);    // turn on interrupt on PS3
  pulse.setReg(PulsePlug::IRQ_ENABLE, 0x0F);    // turn on interrupt on PS12 JJ
  // pulse.setReg(PulsePlug::IRQ_MODE2, 0x01);     // interrupt on ps3 measurement
  pulse.setReg(PulsePlug::IRQ_MODE1, 0x0F);     // interrupt on ps2 AND PS1 measurement
  pulse.setReg(PulsePlug::MEAS_RATE, 0x84);     // see datasheet -- every 10ms
 // pulse.setReg(PulsePlug::MEAS_RATE, 0x08);     // every 100ms
  pulse.setReg(PulsePlug::ALS_RATE, 0x08);      // see datasheet ---- one measurement
  pulse.setReg(PulsePlug::PS_RATE, 0x08);       // see datasheet --every time the device wakes up
  pulse.setReg(PulsePlug::PS_LED3, 0x02);
  pulse.setReg(PulsePlug::PS_LED21, 0x00);      // this powers off the green leds of the ID107HR
  pulse.writeParam(PulsePlug::PARAM_CH_LIST, 0x77);         // all measurements on
  pulse.writeParam(PulsePlug::PARAM_PS_ADC_GAIN, 0x00);
  pulse.writeParam(PulsePlug::PARAM_PSLED12_SELECT, 0x21);  // 21 = LED 2 & LED 1 (red) resp.
  pulse.writeParam(PulsePlug::PARAM_PS1_ADCMUX, 0x03);      // PS1 photodiode select
  pulse.writeParam(PulsePlug::PARAM_PS2_ADCMUX, 0x03);      // PS2 photodiode select
  pulse.writeParam(PulsePlug::PARAM_PS3_ADCMUX, 0x03);      // PS3 photodiode select
  pulse.writeParam(PulsePlug::PARAM_PS_ADC_COUNTER, B01110000);    // B01110000 is default
  pulse.setReg(PulsePlug::COMMAND, PulsePlug::PSALS_AUTO_Cmd);     // starts an autonomous read loop

}



